<template>
	<div class="system-edit-user-container">
		<el-dialog :title="titles" v-model="isShowDialog" width="769px" draggable :fullscreen="full" @close="closeDialog(ruleFormRef)">
			<el-button @click="toggleFullscreen" size="small" class="pot" :icon="FullScreen"></el-button>
			<el-form ref="ruleFormRef" :model="ruleForm" size="default" label-width="120px" :rules="rules">
				<el-row :gutter="35">
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="申报人姓名" prop="declareUserName">
							<el-input v-model="ruleForm.declareUserName" :disabled="disabled" placeholder="请填写申报人姓名"></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="申报人性别" prop="declareUserGender">
							<el-radio-group v-model="ruleForm.declareUserGender" :disabled="disabled">
								<el-radio :label="false">男</el-radio>
								<el-radio :label="true">女</el-radio>
							</el-radio-group>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="申报人部门" placeholder="请选择" prop="declareDepartmentId">
							<el-tree-select v-model="ruleForm.declareDepartmentId" :disabled="disabled"
											:data="newTreeList" :props="propse" class="w100" placeholder="请选择" />
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="事故名称" prop="accidentName">
							<el-input v-model="ruleForm.accidentName" :disabled="true" placeholder="请选择" class="input-with-select">
								<template #append>
									<el-button :icon="Search" @click="daiInpt" />
								</template>
							</el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="事故发生时间" prop="occurrenceTime">
							<el-date-picker
								v-model="ruleForm.occurrenceTime"
								:disabled="true"
								type="datetime"
								class="w100"
								placeholder="选择日期时间"
								value-format="YYYY-MM-DD HH:mm:ss"
							/>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="工伤类型" prop="workInjuryType">
							<el-select v-model="ruleForm.workInjuryType" :disabled="disabled" class="w100" placeholder="请选择">
								<el-option label="轻微伤" value="轻微伤"></el-option>
								<el-option label="轻伤" value="轻伤"></el-option>
							</el-select>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="申报日期" prop="declareDate">
							<el-date-picker
								v-model="ruleForm.declareDate"
								:disabled="disabled"
								type="datetime"
								class="w100"
								placeholder="选择日期时间"
								value-format="YYYY-MM-DD HH:mm:ss"
							/>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="损失工时" prop="lostTime">
							<el-input v-model="ruleForm.lostTime" :disabled="disabled" placeholder="请填写损失工时"></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="就诊医院" prop="visitHospital">
							<el-input v-model="ruleForm.visitHospital" :disabled="disabled" placeholder="请填写就诊医院"></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="就诊结果" prop="visitResult">
							<el-input v-model="ruleForm.visitResult" :disabled="disabled" placeholder="请填写就诊结果"></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
						<el-form-item label="相关附件">
							<uploaderImg :fileList="fileList" :disabled="disabled"></uploaderImg>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="注意事项" prop="mattersNeedingAttention">
							<el-input v-model="ruleForm.mattersNeedingAttention" :disabled="disabled" placeholder="请填写注意事项"></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="材料是否齐全" prop="completeMaterials">
							<el-radio-group v-model="ruleForm.completeMaterials" :disabled="disabled">
								<el-radio :label="false">否</el-radio>
								<el-radio :label="true">是</el-radio>
							</el-radio-group>
						</el-form-item>
					</el-col>

					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12" class="mb20">
						<el-form-item label="备注" prop="remark">
							<el-input v-model="ruleForm.remark" :disabled="disabled" type="textarea" placeholder="请填写备注" maxlength="150"></el-input>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="resetForm(ruleFormRef)" size="default">关闭</el-button>
					<el-button size="default" type="primary" v-if="disabled == true ? false : true" @click="submitForm(titles, ruleFormRef)">确定</el-button>
				</span>
			</template>
		</el-dialog>
		<AccidentName @selectItem="onSelectItem" ref="showRef" />
		<userSelections ref="userRef" />
		<RegionsDialog ref="openRef" />
	</div>
</template>

<script lang="ts">
import {
	reactive,
	ref,
	defineComponent,
	onMounted
} from 'vue';

import type { UploadUserFile, FormInstance,FormRules } from 'element-plus';
import { ElMessage } from 'element-plus';
import { Search, FullScreen } from '@element-plus/icons-vue';
import UserSelections from '/@/components/userSelections/index.vue';
import AccidentName from '/@/views/accidentManagementSystem/workInjuryDeclaration/component/accidentName.vue';
import RegionsDialog from '/@/components/regionsDialog/index.vue';
import uploaderImg from '/@/components/uploaderImg/index.vue';
import { emergencySuppliesApi } from '/@/api/emergencyResources';
import { accidentManagementSystemApi } from '/@/api/workInjuryDeclaration';
import { goalManagementApi } from '/@/api/goalManagement';

export default defineComponent({
	name: 'openAdd',
	components: {
		AccidentName,
		UserSelections,
		RegionsDialog,
		uploaderImg
	},
	setup(props, { emit }) {
		const isShowDialog = ref(false);

		const ruleFormRef = ref<FormInstance>();
		//定义表单
		const ruleForm = ref({
			declareUserName: '',
			declareUserGender: '',
			declareDepartmentId: '',
			accidentName:'',
			accidentExpressId: '',
			workInjuryType: '',
			declareDate: '',
			lostTime: '',
			visitHospital: '',
			visitResult: '',
			mattersNeedingAttention: '',
			completeMaterials: '',
			remark: '',
			fileList: [
				{
					fileName: '',
					fileUrl: '',
				},
			],
		});
		const titles = ref();
		const disabled = ref();
		// 打开弹窗
		const openDialog = (title: string, id: number, type: boolean) => {
			isShowDialog.value = true;
			titles.value = title;
			disabled.value = type;
			if (title == '查看工伤申报' || title == '修改工伤申报') {
				accidentManagementSystemApi()
					.seeAccidentManagementSystem(id)
					.then((res) => {
						if (res.data.code == 200) {
							ruleForm.value = res.data.data;
						}
					});
			}
		};
		//日期选择器
		const value1 = ref('');
		// 上传附件
		const fileList = ref<UploadUserFile[]>([]);
		// 可选择树
		const treeSelect = ref();
		const tree = [
		];
		//定义树形下拉框
		const responsibleDepartment = ref();
		const data = [

		];
		//el-tree-select回显
		const propse = {
			label: 'depName',
			children: 'children',
		};
		const newTreeList = [];
		//得到部门树
		const department = async () => {
			await goalManagementApi()
					.getTreedepartment()
					.then((res) => {
						if (res.data.code == 200) {
							data.value = res.data.data;
							getTreeList(res.data.data, newTreeList);
						} else {
							ElMessage.error(res.data.msg);
						}
					});
		};
		// 递归树状数据且修改字段名
		const getTreeList = (treeList, newTreeList) => {
			treeList.map((c) => {
				let tempData = {
					depName: c.depName,
					value: c.depId,
					children: [],
				};
				if (c.children && c.children.length > 0) {
					tempData.children = [];
					getTreeList(c.children, tempData.children);
				}
				newTreeList.push(tempData);
			});
		};
		onMounted(() => {
			department();
		});
		// 关闭弹窗
		const closeDialog = (formEl: FormInstance | undefined) => {
			formEl.resetFields();
			isShowDialog.value = false;
		};
		// 必填项提示
		const rules = reactive<FormRules>({
			declareUserName: [
				{
				  required: true,
				  message: '申报人姓名不能为空',
				  trigger: 'change',
				},
			  ],
			declareUserGender: [
				{
				  required: true,
				  message: '申报人性别不能为空',
				  trigger: 'change',
				},
			  ],
			declareDepartmentId: [
				{
				  required: true,
				  message: '申报人部门不能为空',
				  trigger: 'change',
				},
			  ],
			accidentName: [
				{
				  required: true,
				  message: '事故名称不能为空',
				  trigger: 'change',
				},
			  ],
			workInjuryType: [
				{
				  required: true,
				  message: '工伤类型不能为空',
				  trigger: 'change',
				},
			  ],
			declareDate: [
				{
				  required: true,
				  message: '申报日期不能为空',
				  trigger: 'blur',
				},
			  ],
			lostTime: [
				{
					required: true,
					message: '损失工时不能为空',
					trigger: 'change',
				},
			],
			visitHospital: [
				{
					required: true,
					message: '就诊医院不能为空',
					trigger: 'change',
				},
			],
			visitResult: [
				{
					required: true,
					message: '就诊结果不能为空',
					trigger: 'change',
				},
			],
			mattersNeedingAttention: [
				{
					required: true,
					message: '注意事项不能为空',
					trigger: 'change',
				},
			],
			completeMaterials: [
				{
					required: true,
					message: '材料状态不能为空',
					trigger: 'change',
				},
			],
			remark: [
				{
					required: true,
					message: '备注不能为空',
					trigger: 'change',
				},
			]
		})

		// 事故名称弹窗
		const showRef = ref();
		const daiInpt = () => {
			showRef.value.openDailog();
		};
		//事故快报回填
		const onSelectItem = (item: any) => {
			console.log('item', item);
			ruleForm.value.accidentExpressId = item[0].id
			ruleForm.value.accidentName = item[0].accidentName
			ruleForm.value.occurrenceTime = item[0].occurrenceTime

		};
		// 表单提交验证必填项
		const submitForm = async (title: string, formEl: FormInstance | undefined) => {
			if (title == '新建工伤申报') {
				if (!formEl) return;
				await formEl.validate((valid, fields) => {
					if (valid) {
						isShowDialog.value = false;
						accidentManagementSystemApi()
							.workAdd(ruleForm.value)
							.then((res) => {
								if (res.data.code == 200) {
									ElMessage({
										showClose: true,
										message: res.data.msg,
										type: 'success',
									});
									emit('myAdd', true);
								} else {
									ElMessage({
										showClose: true,
										message: res.data.msg,
										type: 'error',
									});
									emit('myAdd', true);
								}
								formEl.resetFields();
							});
					} else {
						console.log('error submit!', fields);
					}
				});
			} else if (title == '修改工伤申报') {
				if (!formEl) return;
				await formEl.validate((valid, fields) => {
					if (valid) {
						isShowDialog.value = false;
						accidentManagementSystemApi()
							.workView(ruleForm.value)
							.then((res) => {
								if (res.data.code == 200) {
									ElMessage({
										showClose: true,
										message: '修改成功',
										type: 'success',
									});
									emit('myAdd', true);
								} else {
									ElMessage({
										showClose: true,
										message: res.data.msg,
										type: 'error',
									});
									emit('myAdd', true);
								}
								formEl.resetFields();
							});
					} else {
						console.log('error submit!', fields);
					}
				});
				formEl.resetFields();
				ruleForm.value = {
					declareUserName: '',
					declareUserGender: '',
					declareDepartmentId: '',
					accidentExpressId: '',
					workInjuryType: '',
					declareDate: '',
					lostTime: '',
					visitHospital: '',
					visitResult: '',
					mattersNeedingAttention: '',
					completeMaterials: '',
					remark: '',
					fileList: [
						{
							fileName: '',
							fileUrl: '',
						},
					],
				};
			}
		};
		const resetForm = (formEl: FormInstance | undefined) => {
			isShowDialog.value = false;
			if (!formEl) return;
			formEl.resetFields();
		};
		// 选择区域弹窗
		const openRef = ref();
		const regionsDialog = () => {
			openRef.value.openDailog();
		};
		// 打开用户选择弹窗
		const userRef = ref();
		const openUser = () => {
			userRef.value.openDialog();
		};
		//全屏
		const full = ref(false);
		const toggleFullscreen = () => {
			if (full.value == false) {
				full.value = true;
			} else {
				full.value = false;
			}
		};
		return {
			daiInpt,
			openDialog,
			isShowDialog,
			fileList,
			responsibleDepartment,
			data,
			Search,
			ruleForm,
			value1,
			treeSelect,
			tree,
			showRef,
			ruleFormRef,
			submitForm,
			rules,
			openUser,
			userRef,
			regionsDialog,
			openRef,
			toggleFullscreen,
			FullScreen,
			full,
			resetForm,
			titles,
			disabled,
			emit,
			onSelectItem,
			department,
			getTreeList,
			newTreeList,
			propse,
			closeDialog,
			uploaderImg
		};
	},
});
</script>
<style scoped lang="scss">
.textarea {
	height: 168px !important;
}
.textarea ::v-deep .el-textarea__inner {
	height: 168px !important;
}
::v-deep .el-table__cell {
	font-weight: 400;
}
.el-divider--horizontal {
	height: 0;
	margin: 0;
	border-top: transparent;
}
.el-select {
	width: 100%;
}
</style>
